#include "modelforpointers.h"

ModelForPointers::ModelForPointers(QObject *parent) :
    QSqlTableModel(parent)
{
     setEditStrategy(QSqlTableModel::OnManualSubmit);
}

Qt::ItemFlags ModelForPointers::flags(
         const QModelIndex &index) const {
Qt::ItemFlags flags = QSqlTableModel::flags(index);
if ((index.column() != 3) && (index.column() != 0))
     flags |= Qt::ItemIsEditable;
//if (index.column() == 4)
//     flags |= Qt::ItemIsUserCheckable;
else
{
    if ((index.column() == 3) || (index.column() == 0)) flags &= ~Qt::ItemIsEditable; //    
}
    return flags;
}


bool ModelForPointers::setData(const QModelIndex &index, const QVariant &value, int role) {
  ////  if (index.column()==3) return false; //       
    bool lResult = false;
    QVariant old_value; //   
    old_value = data(index);

    if (index.column()==1){ //    
        QSqlQuery qu;
        QString old_field_name; //   
        QString new_field_name; //   
        QString query_str;
        QString type_str; //   
        old_field_name = old_value.toString(); //   (  )  
        new_field_name = value.toString();
        // type_str = data(ModelForPointers::index(index.row(), 3)).toString(); //     3 ,   
        type_str = tr("CHAR(10)");

        query_str = tr("ALTER TABLE ");
        query_str.append(ModelForPointers::Inctance);
        query_str.append(tr(" CHANGE COLUMN `"));
        query_str.append(old_field_name);
        query_str.append(tr("` `"));
        query_str.append(new_field_name);
        query_str.append(tr("` "));
        query_str.append(type_str);
        query_str.append(tr(" CHARACTER SET cp1251 COLLATE cp1251_general_ci DEFAULT NULL"));
        qu.prepare(query_str);
        bool ok;
        ok = qu.exec();
        if (!ok) return false;
    }



    lResult = QSqlTableModel::setData(index, value, role);
    if (lResult) {
        QModelIndex newindex;
        QSqlRecord rec = record(index.row());

        rec.setValue(index.column(), value);
        rec.setGenerated(index.column(), true);


        lResult = updateRowInTable(index.row(), rec);
        emit field_changed();
  ///      QSqlTableModel::setData(newindex, QVariant(str_tmp), Qt::EditRole);


    }
    return lResult;
}



QVariant ModelForPointers::data(const QModelIndex &index, int role) const {

     QVariant value = QSqlTableModel::data(index, role);
  switch (role) {
        case Qt::DisplayRole: {
                if(index.column() == 4){
                QSqlQuery q;
                QString sql_str;
                bool ok;
                sql_str = tr("select * from `ListOfClasses` where `ID` = ");
                sql_str.append(value.toString());

                q.prepare(sql_str);

                ok = q.exec();

                if (ok)  {
                             while(q.next()){
                               QString class_name = q.value(1).toString();
                               if (!class_name.isEmpty()) return class_name;

                                               }


                          }

            }


                return value;
            }



        case Qt::EditRole: return value;
        case Qt::TextColorRole:
            if(index.column() == 1)
                return qVariantFromValue(QColor(Qt::blue));
            else
              return value;
        case Qt::TextAlignmentRole: return value;
        case Qt::FontRole:
           if(index.column() == 1) {
               QFont font = QFont("Helvetica", 16, QFont::Bold);
              return qVariantFromValue(font);
           }else
               return value;

       case Qt::BackgroundColorRole: {
                int a = (index.row() % 2) ? 14 : 0;
                if(index.column() == 2)
                           return qVariantFromValue(QColor(220,240-a,230-a));
                        else if(index.column() == 4)
                            return qVariantFromValue(QColor(200,220-a,255-a));
                        else
                           return value;
                                    }



     case Qt::CheckStateRole: return value;

     case Qt::SizeHintRole:return value;

       }
  return value;
}

void ModelForPointers::setInctance(QString currInctatce){ //    -
    ModelForPointers::Inctance = currInctatce;
}


bool ModelForPointers::onlySetData(const QModelIndex &index, const QVariant &value, int role){
     bool lResult = false;

     QSqlRecord rec = record(index.row());
     rec.setValue(index.column(), value);
     rec.setGenerated(index.column(), true);


     lResult = QSqlTableModel::setData(index, value, role);
     if (lResult) {
     lResult = updateRowInTable(index.row(), rec);
 //    emit field_changed();
///      QSqlTableModel::setData(newindex, QVariant(str_tmp), Qt::EditRole);
                 }




 return lResult;

}


